class ClassicSniperFire extends SniperFire;

function DoTrace(Vector Start, Rotator Dir)
{
    local Vector X,Y,Z, End, HitLocation, HitNormal;
    local Actor Other;
    local xEmitter hitEmitter;
    local float  dist;
    local vector arcEnd;

    Weapon.GetViewAxes(X, Y, Z);
    if ( Weapon.WeaponCentered() )
        arcEnd = (Instigator.Location + 
			Weapon.EffectOffset.X * X + 
			1.5 * Weapon.EffectOffset.Z * Z); 
	else
        arcEnd = (Instigator.Location + 
			Instigator.CalcDrawOffset(Weapon) + 
			Weapon.EffectOffset.X * X + 
			Weapon.Hand * Weapon.EffectOffset.Y * Y + 
			Weapon.EffectOffset.Z * Z); 
    
    X = Vector(Dir);
    End = Start + TraceRange * X;
    Other = Trace(HitLocation, HitNormal, End, Start, true);

    if ( Other != None )
    {
		if ( Other.bWorldGeometry )
			HitLocation = HitLocation + 2.0 * HitNormal;
		else
        {
 			if ( (Pawn(Other) != None) 
				&& Other.GetClosestBone( HitLocation, X, dist, 'head', HeadShotRadius ) == 'head' )
                Other.TakeDamage(DamageMin * HeadShotDamageMult, Instigator, HitLocation, Momentum*X, DamageTypeHeadShot);
            else
                Other.TakeDamage(DamageMin, Instigator, HitLocation, Momentum*X, DamageType);
        }
    }
    else
    {
        HitLocation = End;
        HitNormal = Normal(Start - End);
    }
    hitEmitter = Spawn(HitEmitterClass,,, arcEnd, Rotator(HitNormal));
    if ( hitEmitter != None )
    {
		hitEmitter.mSpawnVecA = HitLocation;
		hitEmitter.mLifeRange[0] = 0.3;
		hitEmitter.mLifeRange[1] = 0.3;
	}
}

defaultproperties
{
    DamageMin=60
    DamageMax=60
    FireRate=1.4
	FireAnimRate=1.427
    HeadShotRadius=6.5
}
