class MutUTClassic extends Mutator;

var class<Weapon> OriginalClasses[8];
var class<Weapon> ReplacementClasses[8];
var config bool bCanDoubleJump;
var config bool bCanWallDodge;
var config bool bCanDodgeDoubleJump;

function PostBeginPlay()
{
	local GameRules G;
	
	Super.PostBeginPlay();
	G = spawn(class'UTClassicGameRules');
	if ( Level.Game.GameRulesModifiers == None )
		Level.Game.GameRulesModifiers = G;
	else    
		Level.Game.GameRulesModifiers.AddGameRules(G);
	Level.Game.bModViewShake = false;
	Level.Game.bForceClassicView = true;
}

function bool CheckReplacement( Actor Other, out byte bSuperRelevant )
{
	local int i;
	
	bSuperRelevant = 0;
	if ( xPawn(Other) != None )
	{
		if ( !bCanDoubleJump )
			xPawn(Other).MaxMultiJump = 0;
		xPawn(Other).bCanWallDodge = bCanWallDodge;
		xPawn(Other).bCanDodgeDoubleJump = bCanDodgeDoubleJump;
		xPawn(Other).bNoShieldStacking = true;
		xPawn(Other).RequiredEquipment[1] = "UTClassic.ClassicShieldGun";
		if ( Deathmatch(Level.Game).bAllowTrans )
			xPawn(Other).RequiredEquipment[2] = "UTClassic.ClassicTranslauncher";
	}
    else if ( xWeaponBase(Other) != None )
    {
		for ( i=0; i<8; i++ )
			if ( xWeaponBase(Other).WeaponType == OriginalClasses[i] )
			{
				xWeaponBase(Other).WeaponType = ReplacementClasses[i];
				return true;
			}
	}
	else if ( Translauncher(Other) != None )
	{
		if ( ClassicTransLauncher(Other) == None )
			return false;
	}
	return true;
}    

defaultproperties
{
    IconMaterialName="MutatorArt.nosym"
    GroupName="Arena"
    FriendlyName="UT Classic"
    Description="Classic UT style weapons."
    
    OriginalClasses(0)=class'FlakCannon'
    OriginalClasses(1)=class'Minigun'
    OriginalClasses(2)=class'ShockRifle'
    OriginalClasses(3)=class'RocketLauncher'
    OriginalClasses(4)=class'SniperRifle'
    OriginalClasses(5)=class'BioRifle'
    OriginalClasses(6)=class'Translauncher'
    OriginalClasses(7)=class'ShieldGun'

    ReplacementClasses(0)=class'ClassicFlakCannon'
    ReplacementClasses(1)=class'ClassicMinigun'
    ReplacementClasses(2)=class'ClassicShockRifle'
    ReplacementClasses(3)=class'ClassicRocketLauncher'
    ReplacementClasses(4)=class'ClassicSniperRifle'
    ReplacementClasses(5)=class'ClassicBioRifle'
    ReplacementClasses(6)=class'ClassicTranslauncher'
    ReplacementClasses(7)=class'ClassicShieldGun'
    
    bCanDoubleJump=true
    bCanWallDodge=true
    bCanDodgeDoubleJump=true
}