class CustomBotConfig extends Object
	abstract
	config;

struct CustomConfiguration
{
	var config string CharacterName;		// name of character (from UPL) to modify
	var config string PlayerName;			// name to change playername to.
	var() config string FavoriteWeapon;
	var() config float Aggressiveness;		// 0 to 1 (0.3 default, higher is more aggressive)
	var() config float Accuracy;			// -1 to 1 (0 is default, higher is more accurate)
	var() config float CombatStyle;		// 0 to 1 (0= stay back more, 1 = charge more)
	var() config float StrafingAbility;	// -1 to 1 (higher uses strafing more)
	var() config float Tactics;			// -1 to 1 (higher uses better team tactics)
	var() config float ReactionTime;
	var config bool bJumpy;
};

var config array<CustomConfiguration> ConfigArray;

/* Used to configure custom bot AI parameters
*/
static function Customize(RosterEntry R)
{
	local int i;

	for ( i=0; i<Default.ConfigArray.Length; i++ )
		if ( R.PlayerName ~= Default.ConfigArray[i].CharacterName )
		{
			R.ModifiedPlayerName = Default.ConfigArray[i].PlayerName;
			R.FavoriteWeapon = class<Weapon>(DynamicLoadObject(Default.ConfigArray[i].FavoriteWeapon, class'Class'));
			R.Aggressiveness = Default.ConfigArray[i].Aggressiveness;
			R.Accuracy = Default.ConfigArray[i].Accuracy;
			R.CombatStyle = Default.ConfigArray[i].CombatStyle;
			R.StrafingAbility = Default.ConfigArray[i].StrafingAbility;
			R.Tactics = Default.ConfigArray[i].Tactics;
			R.ReactionTime = Default.ConfigArray[i].ReactionTime;
			R.bJumpy = Default.ConfigArray[i].bJumpy;
			return;
		}
}

static function int IndexFor(string PlayerName)
{
	local int i;

    for (i=0; i<Default.ConfigArray.Length; i++)
    	if (PlayerName ~= Default.ConfigArray[i].CharacterName)
        	return i;

    return -1;
}