//=============================================================================
// DMMutator.
//=============================================================================

class DMMutator extends Mutator
	config;

var() globalconfig bool bMegaSpeed;
var() globalconfig float AirControl;
var() globalconfig bool bBrightSkins;

// mc - localized PlayInfo descriptions & extra info
var private localized string DMMutPropsDisplayText[3];

function bool MutatorIsAllowed()
{
	return true;
}

function bool AlwaysKeep(Actor Other)
{
	if ( NextMutator != None )
		return ( NextMutator.AlwaysKeep(Other) );
	return false;
}

function ModifyPlayer(Pawn Other)
{
	Other.AirControl = AirControl;
	Other.AirControl = AirControl;
	Other.bAutoActivate = true;
	if ( bMegaSpeed )
	{
		Other.GroundSpeed = 1.4 * Other.Default.GroundSpeed;
		Other.WaterSpeed = 1.4 * Other.Default.WaterSpeed;
		Other.AirSpeed = 1.4 * Other.Default.AirSpeed;
		Other.AccelRate = 1.4 * Other.Default.AccelRate;
	}
	if ( NextMutator != None )
		NextMutator.ModifyPlayer(Other);
}

static function FillPlayInfo(PlayInfo PlayInfo)
{
	local int i;

	Super.FillPlayInfo(PlayInfo);  // Always begin with calling parent

	PlayInfo.AddSetting("Game",  "bMegaSpeed", default.DMMutPropsDisplayText[i++], 1, 70, "Check");
	PlayInfo.AddSetting("Game",  "AirControl", default.DMMutPropsDisplayText[i++], 1, 90, "Text", "8;0.1:10.0");
}

defaultproperties
{
	bBrightSkins=false
	AirControl=+0.35
	DefaultWeaponName=""
	DMMutPropsDisplayText(0)="Mega Speed"
	DMMutPropsDisplayText(1)="Air Control"
    DMMutPropsDisplayText(2)="Bright Skins"
}