//=============================================================================
// xDeathMatch.
//=============================================================================
class xDeathMatch extends DeathMatch;

#exec OBJ LOAD FILE=WeaponSkins.utx
#exec OBJ LOAD FILE=XEffectMat.utx
#exec OBJ LOAD FILE=WeaponStaticMesh.usx

static function PrecacheGameTextures(LevelInfo myLevel)
{
	local int i;
	local array<xUtil.PlayerRecord> AllPlayerList, PlayerList;
	local bool bIsTeamGame;
	local class<GameInfo> GameClass;
	
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.AssaultTex0');
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.GrenadeEndTex');
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.GrenadeTex');
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.ShieldTex0');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.TransRingEnergy');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.Minigun_burst');
	myLevel.AddPrecacheMaterial(Material'XEffects.pcl_Spark');
	myLevel.AddPrecacheMaterial(Material'XEffects.EmitSmoke_t');
	myLevel.AddPrecacheMaterial(Material'XEffects.SmokeTex');
	myLevel.AddPrecacheMaterial(Material'XEffects.rocketblastmark');
    myLevel.AddPrecacheMaterial(Texture'XEffects.FlakTrailTex');
	myLevel.AddPrecacheMaterial(Material'XEffects.Rexpt');
	myLevel.AddPrecacheMaterial(Material'XEffects.SmokeAlphab_t');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.shock_ring_b');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.shield_elec_green_a');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.SlimeSkin');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.goop_green_a');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.edgegrad');
	myLevel.AddPrecacheMaterial(Material'XGameShadersB.TransRingEnergyRed');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.PlayerShield');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.Shield3rdFB');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.ShieldRip3rdFB');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.LinkGunShell');
	myLevel.AddPrecacheMaterial(Material'Engine.BlobTexture');
	myLevel.AddPrecacheMaterial(Material'EpicParticles.Sharpstreaks2');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.LEnergy');
	
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.TransLauncherTex0');
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.BioRifleGlass0');
	myLevel.AddPrecacheMaterial(Material'WeaponSkins.TransBeaconTex0');
	myLevel.AddPrecacheMaterial(Material'XEffects.TransTrailT');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.TransPlayerCell');
	myLevel.AddPrecacheMaterial(Material'XGameShaders.TransPlayerCellRed');
	myLevel.AddPrecacheMaterial(Material'XEffects.GreySpark');

	myLevel.AddPrecacheMaterial(Material'EpicParticles.DeRez01aw');
	myLevel.AddPrecacheMaterial(Material'DeRez.DeRezSkin');
	myLevel.AddPrecacheMaterial(Material'DeRez.RezTest4');
	
	if ( Default.bPreloadAllSkins || myLevel.bShouldPreload )
	{
		class'xUtil'.static.GetPlayerList(AllPlayerList);

		// Filter out 'duplicate' characters - only used in single player
		for(i=0; i<AllPlayerList.Length; i++)
		{
			if(AllPlayerList[i].Menu != "DUP")
				PlayerList[PlayerList.Length] = AllPlayerList[i];
		}
		GameClass = myLevel.GetGameClass();
		bIsTeamGame = (GameClass != None) && GameClass.Default.bTeamGame;
		for (i=0; i<PlayerList.Length; i++ )
		{
			DynamicLoadObject(PlayerList[i].MeshName,Class'Mesh');
			if ( !bIsTeamGame )
				DynamicLoadObject(PlayerList[i].BodySkinName,Class'Material');
			DynamicLoadObject(PlayerList[i].FaceSkinName,Class'Material');
			if ( PlayerList[i].VoiceClassName != "" )
				DynamicLoadObject(PlayerList[i].VoiceClassName,Class'Class');
		}
	}		
}

static function PrecacheGameStaticMeshes(LevelInfo myLevel)
{
	myLevel.AddPrecacheStaticMesh(StaticMesh'WeaponStaticMesh.shield');
	myLevel.AddPrecacheStaticMesh(StaticMesh'WeaponStaticMesh.grenademesh');
	myLevel.AddPrecacheStaticMesh(StaticMesh'WeaponStaticMesh.AssaultRiflePickup');
}
	
defaultproperties
{
    MapListType="XInterface.MapListDeathMatch"
    HUDType="XInterface.HudBDeathMatch"
	DeathMessageClass=class'XGame.xDeathMessage'

    ScreenShotName="MapThumbnails.ShotDeathmatch"
    DecoTextName="XGame.Deathmatch"

    Acronym="DM"
    DefaultEnemyRosterClass="XGame.xDMRoster"
}
