//=============================================================================
// Copyright 2001 Digital Extremes - All Rights Reserved.
// Confidential.
//=============================================================================
class xTeamGame extends TeamGame;

#exec OBJ LOAD FILE=TeamSymbols.utx				// needed right now for Link symbols, etc.

static function PrecacheGameTextures(LevelInfo myLevel)
{
	local int i;
	local array<xUtil.PlayerRecord> AllPlayerList, PlayerList;
	
	class'xDeathMatch'.static.PrecacheGameTextures(myLevel);

	myLevel.AddPrecacheMaterial(Material'TeamSymbols.TeamBeaconT');
	myLevel.AddPrecacheMaterial(Material'TeamSymbols.LinkBeaconT');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.RedShell');
	myLevel.AddPrecacheMaterial(Material'XEffectMat.BlueShell');

	// preload team skins
	if ( Default.bPreloadAllSkins || myLevel.bShouldPreload )
	{
		class'xUtil'.static.GetPlayerList(AllPlayerList);

		// Filter out 'duplicate' characters - only used in single player
		for(i=0; i<AllPlayerList.Length; i++)
		{
			if(AllPlayerList[i].Menu != "DUP")
				PlayerList[PlayerList.Length] = AllPlayerList[i];
		}
		
		for (i=0; i<PlayerList.Length; i++ )
		{
			if ( class'DMMutator'.Default.bBrightSkins && (MyLevel.NetMode != NM_DedicatedServer) && (Left(PlayerList[i].BodySkinName,12) ~= "PlayerSkins.") )
			{
				DynamicLoadObject("Bright"$PlayerList[i].BodySkinName$"_0B",Class'Material',true);
				DynamicLoadObject("Bright"$PlayerList[i].BodySkinName$"_1B",Class'Material',true);
			}
			else
			{
				DynamicLoadObject(PlayerList[i].BodySkinName$"_0",Class'Material');
				DynamicLoadObject(PlayerList[i].BodySkinName$"_1",Class'Material');
			}
		}
	}		

}

static function PrecacheGameStaticMeshes(LevelInfo myLevel)
{
	class'xDeathMatch'.static.PrecacheGameStaticMeshes(myLevel);
}

defaultproperties
{
    MapListType="XInterface.MapListTeamDeathMatch"
    HUDType="XInterface.HudBTeamDeathMatch"
    DeathMessageClass=class'XGame.xDeathMessage'
	DefaultEnemyRosterClass="xGame.xTeamRoster"

    ScreenShotName="MapThumbnails.ShotTeamGame"
    DecoTextName="XGame.TeamGame"

    Acronym="TDM"
}