class UT2BotConfigPage extends GUIPage;

var localized string NoInformation;
var GUIImage BotPortrait;
var GUILabel BotName;

var int ConfigIndex;
var xUtil.PlayerRecord ThisBot;
var bool bIgnoreChange;

var array<class<Weapon> > WeaponClass;
var array<string> 		  WeaponDesc;

var moComboBox Wep;

function InitComponent(GUIController MyController, GUIComponent MyOwner)
{
	local int i;
	Super.Initcomponent(MyController, MyOwner);
	BotPortrait=GUIImage(Controls[1]);
	BotName=GUILabel(Controls[3]);

	Controller.GetWeaponList(WeaponClass,WeaponDesc);
    Wep = moComboBox(Controls[19]);
    Wep.AddItem("None");
    for (i=0;i<WeaponClass.Length;i++)
    {
    	Wep.AddItem(WeaponClass[i].default.ItemName);
    }

    Wep.Onchange=ComboBoxChange;


}

function SetupBotInfo(Material Portrait, string DecoTextName, xUtil.PlayerRecord PRE)
{

    ThisBot = PRE;

	// Setup the Portrait from here
	BotPortrait.Image = PRE.Portrait;
	// Setup the decotext from here
	BotName.Caption = PRE.DefaultName;

    ConfigIndex = class'CustomBotConfig'.static.IndexFor(PRE.DefaultName);

	bIgnoreChange = true;
    if (ConfigIndex>=0)
    {
    	GUISlider(Controls[7]).SetValue(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Aggressiveness);
    	GUISlider(Controls[9]).SetValue(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Accuracy);
    	GUISlider(Controls[11]).SetValue(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].CombatStyle);
    	GUISlider(Controls[13]).SetValue(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].StrafingAbility);
    	GUISlider(Controls[15]).SetValue(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Tactics);
        GUISlider(Controls[17]).SetValue(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].ReactionTime);
        mocheckBox(Controls[18]).Checked(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].bJumpy);

        Wep.SetIndex(findIndexOf(class'CustomBotConfig'.default.ConfigArray[ConfigIndex].FavoriteWeapon));

    }
    else
	{
    	GUISlider(Controls[7]).SetValue(float(PRE.Aggressiveness));
    	GUISlider(Controls[9]).SetValue(float(PRE.Accuracy));
    	GUISlider(Controls[11]).SetValue(float(PRE.CombatStyle));
    	GUISlider(Controls[13]).SetValue(float(PRE.StrafingAbility));
    	GUISlider(Controls[15]).SetValue(float(PRE.Tactics));
    	GUISlider(Controls[17]).SetValue(float(PRE.ReactionTime));
        moCheckBox(Controls[18]).Checked(bool(PRE.bJumpy));

        Wep.SetIndex(FindIndexOf(PRE.FavoriteWeapon));

    }

    bIgnoreChange=false;

}

function int FindIndexOf(string WeapClass)
{
	local int i;
    local string wc;
    for (i=0;i<WeaponClass.Length;i++)
    {
    	wc = ""$WeaponClass[i];
    	if ( wc ~= WeapClass)
        	return i+1;			// Adjust for NONE
    }

    return 0;
}


function bool OkClick(GUIComponent Sender)
{
	Controller.CloseMenu(false);
	return true;
}

function bool ResetClick(GUIComponent Sender)
{
	bIgnoreChange = true;

	SetDefaults();

   	GUISlider(Controls[7]).SetValue(float(ThisBot.Aggressiveness));
   	GUISlider(Controls[9]).SetValue(float(ThisBot.Accuracy));
   	GUISlider(Controls[11]).SetValue(float(ThisBot.CombatStyle));
   	GUISlider(Controls[13]).SetValue(float(ThisBot.StrafingAbility));
   	GUISlider(Controls[15]).SetValue(float(ThisBot.Tactics));
   	GUISlider(Controls[17]).SetValue(float(ThisBot.ReactionTime));
   	moCheckBox(Controls[18]).Checked(bool(ThisBot.bJumpy));
	Wep.SetIndex(FindIndexOf(ThisBot.FavoriteWeapon));

	class'CustomBotConfig'.static.StaticSaveConfig();

    bIgnorechange = false;

	return true;
}


function int DoPerc(GUISlider Control)
{
	local float r,v,vmin;

    vmin = Control.MinValue;
    r = Control.MaxValue - vmin;
    v = Control.Value - vmin;

    return int(v/r*100);
}



function string AggDC()
{
	return ""$DoPerc( GUISlider(Controls[7]) )$"%";
}

function string AccDC()
{
	return ""$DoPerc(GUISlider(Controls[9]) )$"%";
}

function string ComDC()
{
	return ""$DoPerc(GUISlider(Controls[11]) )$"%";
}

function string StrDC()
{
	return ""$DoPerc(GUISlider(Controls[13]) )$"%";
}

function string TacDC()
{
	return DoPerc(GUISlider(Controls[15]) )$"%";
}

function string ReaDC()
{
	return DoPerc(GUISlider(Controls[17]) )$"%";
}

function SetDefaults()
{
	class'CustomBotConfig'.default.ConfigArray[ConfigIndex].CharacterName = ThisBot.DefaultName;
	class'CustomBotConfig'.default.ConfigArray[ConfigIndex].PlayerName = ThisBot.DefaultName;
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].FavoriteWeapon = ThisBot.FavoriteWeapon;
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Aggressiveness = float(ThisBot.Aggressiveness);
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Accuracy = float(ThisBot.Accuracy);
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].CombatStyle = float(ThisBot.CombatStyle);
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].StrafingAbility = float(ThisBot.StrafingAbility);
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Tactics = float(ThisBot.Tactics);
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].ReactionTime = float(ThisBot.ReactionTime);
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].bJumpy = bool(ThisBot.bJumpy);
}

function SliderChange(GUIComponent Sender)
{
	local GUISlider S;

    S = GUISlider(Sender);

    if ( bIgnoreChange || S == None )
    	return;

	// Look to see if this is a new entry

    if (ConfigIndex==-1)
    {
    	ConfigIndex = class'CustomBotConfig'.Default.ConfigArray.Length;
		class'CustomBotConfig'.Default.ConfigArray.Length = ConfigIndex+1;
        SetDefaults();
    }


	if (S == Controls[7])
      class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Aggressiveness = S.Value;

	else if (S == Controls[9])
      class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Accuracy = S.Value;

	else if (S == Controls[11])
      class'CustomBotConfig'.default.ConfigArray[ConfigIndex].CombatStyle = S.Value;

	else if (S == Controls[13])
      class'CustomBotConfig'.default.ConfigArray[ConfigIndex].StrafingAbility = S.Value;

	else if (S == Controls[15])
      class'CustomBotConfig'.default.ConfigArray[ConfigIndex].Tactics = S.Value;

	else if (S == Controls[17])
      class'CustomBotConfig'.default.ConfigArray[ConfigIndex].ReactionTime = S.Value;

	class'CustomBotConfig'.static.StaticSaveConfig();
}

function CheckBoxChange(GUIComponent Sender)
{
	if (bIgnorechange || Sender!=Controls[18])
    	return;

	// Look to see if this is a new entry

    if (ConfigIndex==-1)
    {
    	ConfigIndex = class'CustomBotConfig'.Default.ConfigArray.Length;
		class'CustomBotConfig'.Default.ConfigArray.Length = ConfigIndex+1;
        SetDefaults();
    }
    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].bJumpy = moCheckBox(Controls[18]).IsChecked();
	class'CustomBotConfig'.static.StaticSaveConfig();

}

function ComboBoxChange(GUIComponent Sender)
{
	local string wc;
    local int i;
	if (bIgnorechange || Sender!=Controls[19])
    	return;

	// Look to see if this is a new entry

    if (ConfigIndex==-1)
    {
    	ConfigIndex = class'CustomBotConfig'.Default.ConfigArray.Length;
		class'CustomBotConfig'.Default.ConfigArray.Length = ConfigIndex+1;
        SetDefaults();
    }

    i = Wep.GetIndex();

	if (i==0)
    	wc = "";
    else
    	wc = ""$WeaponClass[i-1];

    class'CustomBotConfig'.default.ConfigArray[ConfigIndex].FavoriteWeapon = wc;
    class'CustomBotConfig'.static.StaticSaveConfig();

}

defaultproperties
{
	Begin Object class=GUIImage Name=PageBack
		Image=Material'InterfaceContent.Menu.EditBoxDown'
		ImageStyle=ISTY_Stretched
		WinWidth=0.890625
		WinHeight=1.000000
		WinLeft=0.062500
		WinTop=0.000000
		bScaleToParent=true
		bBoundToParent=true
	End Object

	Begin Object class=GUIImage Name=BotPortraitBorder
		WinWidth=0.253125
		WinHeight=0.664258
		WinLeft=0.076563
		WinTop=0.168751
		Image=Material'InterfaceContent.Menu.BorderBoxA1'
		ImageColor=(R=255,G=255,B=255,A=255);
		ImageRenderStyle=MSTY_Normal
		ImageStyle=ISTY_Stretched
	End Object

	Begin Object class=GUIImage Name=imgBotPic
		WinWidth=0.246875
		WinHeight=0.658008
		WinLeft=0.078125
		WinTop=0.170834
		ImageRenderStyle=MSTY_Normal
		ImageStyle=ISTY_Justified
	End Object

	Begin Object class=GUILabel Name=BotCfgName
		WinWidth=0.598437
		WinHeight=0.052539
		WinLeft=0.340820
		WinTop=0.134114
		TextAlign=TXTA_Left
		Caption="Unknown"
		TextFont="UT2LargeFont"
	End Object

	Begin Object class=GUIButton Name=ResetButton
		WinWidth=0.167187
		WinHeight=0.045313
		WinLeft=0.585938
		WinTop=0.825001
		Caption="Reset"
		OnClick=ResetClick
	End Object

	Begin Object class=GUIButton Name=OkButton
		WinWidth=0.167187
		WinHeight=0.045313
		WinLeft=0.765625
		WinTop=0.825001
		Caption="OK"
		OnClick=OkClick
	End Object


	Begin Object class=GUILabel Name=BotAggrText
		Caption="Aggressiveness"
		TextALign=TXTA_Left
		TextColor=(R=255,G=255,B=255,A=255)
		WinWidth=0.250000
		WinHeight=32.000000
		WinLeft=0.344727
		WinTop=0.189583
	End Object

	Begin Object class=GUISlider Name=BotAggrSlider
		WinWidth=0.296875
		WinLeft=0.625000
		WinTop=0.208229
		MinValue=0
		MaxValue=1
		Hint="How Aggressive is this bot."
        OnDrawCaption=AggDC
        OnChange=SliderChange;
	End Object

	Begin Object class=GUILabel Name=BotAccuracyText
		Caption="Accuracy"
		TextALign=TXTA_Left
		TextColor=(R=255,G=255,B=255,A=255)
		WinWidth=0.250000
		WinHeight=32.000000
		WinLeft=0.344727
		WinTop=0.262499
	End Object

	Begin Object class=GUISlider Name=BotAccuracySlider
		WinWidth=0.296875
		WinHeight=0.030000
		WinLeft=0.625000
		WinTop=0.281145
		MinValue=-1
		MaxValue=1
		Hint="How Accurate is this bot."
        OnDrawCaption=AccDC
        OnChange=SliderChange;
	End Object

	Begin Object class=GUILabel Name=BotCStyleText
		Caption="Combat Style"
		TextALign=TXTA_Left
		TextColor=(R=255,G=255,B=255,A=255)
		WinWidth=0.250000
		WinHeight=32.000000
		WinLeft=0.344727
		WinTop=0.335415
	End Object

	Begin Object class=GUISlider Name=BotCStyleSlider
		WinWidth=0.296875
		WinHeight=0.030000
		WinLeft=0.625000
		WinTop=0.354062
		MinValue=0
		MaxValue=1
		Hint="What is this bot's combat style."
        OnDrawCaption=ComDC
        OnChange=SliderChange;
	End Object

	Begin Object class=GUILabel Name=BotStrafeText
		Caption="Strafing Ability"
		TextALign=TXTA_Left
		TextColor=(R=255,G=255,B=255,A=255)
		WinWidth=0.250000
		WinHeight=32.000000
		WinLeft=0.344727
		WinTop=0.408333
	End Object

	Begin Object class=GUISlider Name=BotStrafeSlider
		WinWidth=0.296875
		WinHeight=0.030000
		WinLeft=0.625000
		WinTop=0.426979
		MinValue=0
		MaxValue=1
		Hint="How Well does this bot strafe."
        OnDrawCaption=StrDC
        OnChange=SliderChange;
	End Object

	Begin Object class=GUILabel Name=BotTacticsText
		Caption="Tactics"
		TextALign=TXTA_Left
		TextColor=(R=255,G=255,B=255,A=255)
		WinWidth=0.250000
		WinHeight=32.000000
		WinLeft=0.344727
		WinTop=0.481249
	End Object

	Begin Object class=GUISlider Name=BotTacticsSlider
		WinWidth=0.296875
		WinHeight=0.030000
		WinLeft=0.625000
		WinTop=0.499895
		MinValue=-1
		MaxValue=1
		Hint="Adjust how well this bot plays as a team."
        OnDrawCaption=TacDC
        OnChange=SliderChange;
	End Object

	Begin Object class=GUILabel Name=BotReactionText
		Caption="Reaction Time"
		TextALign=TXTA_Left
		TextColor=(R=255,G=255,B=255,A=255)
		WinWidth=0.250000
		WinHeight=32.000000
		WinLeft=0.344727
		WinTop=0.574999
	End Object

	Begin Object class=GUISlider Name=BotReactionSlider
		WinWidth=0.296875
		WinHeight=0.030000
		WinLeft=0.625000
		WinTop=0.593645
		MinValue=-4
		MaxValue=4
		Hint="Adjust fast does this bot react."
        OnDrawCaption=ReaDC
        OnChange=SliderChange;
	End Object

	Begin Object class=moCheckBox Name=BotJumpy
		WinWidth=0.598438
		WinHeight=0.040000
		WinLeft=0.345313
		WinTop=0.666562
		Caption="Jump Happy"
		Hint="How Jumpy is this bot."
		CaptionWidth=0.9
		bSquare=true
		ComponentJustification=TXTA_Left
        OnChange=CheckBoxChange
	End Object

	Begin Object class=moComboBox Name=BotWeapon
		WinWidth=0.598438
		WinHeight=0.044375
		WinLeft=0.345313
		WinTop=0.729062
		Caption="Preferred Weapon"
		Hint="What weapon does this bot perfer?"
		CaptionWidth=0.45
        bReadOnly=true
		ComponentJustification=TXTA_Left
	End Object


	Controls(0)=PageBack
	Controls(1)=imgBotPic
	Controls(2)=BotPortraitBorder
	Controls(3)=BotCfgName
	Controls(4)=ResetButton
	Controls(5)=OkButton

    Controls(6)=BotAggrText
    Controls(7)=BotAggrSlider
    Controls(8)=BotAccuracyText
    Controls(9)=BotAccuracySlider
    Controls(10)=BotCStyleText
    Controls(11)=BotCStyleSlider
    Controls(12)=BotStrafeText
    Controls(13)=BotStrafeSlider
    Controls(14)=BotTacticsText
    Controls(15)=BotTacticsSlider
    Controls(16)=BotReactionText
    Controls(17)=BotReactionSlider
    Controls(18)=BotJumpy
    Controls(19)=BotWeapon


	WinWidth=1.0
	WinHeight=0.8
	WinTop=0.1
	WinLeft=0.0

	NoInformation="No Information Available!"
}