// ====================================================================
// (C) 2002, Epic Games
// ====================================================================

class UT2ServerInfo extends GUIPage;

var GUITabControl TabC;

function InitComponent(GUIController MyController, GUIComponent MyOwner)
{
 	Super.InitComponent(MyController, MyOwner);

 	GUITitleBar(Controls[2]).Caption = PlayerOwner().GameReplicationInfo.ServerName;

    TabC = GUITabControl(Controls[5]);
	TabC.AddTab("MOTD","xinterface.Tab_ServerMOTD",,"Message of the Day",true);
    TabC.AddTab("Rules","xinterface.Tab_ServerInfo",,"Game Rules",true);
}

function bool ButtonClicked(GUIComponent Sender)
{
	Controller.CloseMenu(true);
    return true;
}

event ChangeHint(string NewHint)
{
	GUITitleBar(Controls[3]).Caption = NewHint;
}


defaultproperties
{
	Begin Object Class=GUIImage name=ServerInfoBackground
		bAcceptsInput=false
		bNeverFocus=true
        Image=Material'InterfaceContent.Menu.BorderBoxD'
        ImageStyle=ISTY_Stretched
        WinWidth=1
        WinLeft=0
        WinHeight=1
        WinTop=0
        bBoundToParent=true
        bScaleToParent=true
	End Object
	Controls(0)=GUIImage'ServerInfoBackground'

	Begin Object Class=GUIImage name=ServerInfoBackground2
		bAcceptsInput=false
		bNeverFocus=true
        Image=Material'InterfaceContent.Menu.BorderBoxD'
        ImageStyle=ISTY_Stretched
        WinWidth=1
        WinLeft=0
        WinHeight=1
        WinTop=0
        bBoundToParent=true
        bScaleToParent=true
	End Object
	Controls(1)=GUIImage'ServerInfoBackground2'


	Begin Object class=GUITitleBar name=ServerInfoHeader
		Caption=""
		StyleName="Header"
        Justification=TXTA_Center
		WinWidth=1
		WinHeight=0.1
		WinLeft=0
		WinTop=0
        bBoundToParent=true
        bScaleToParent=true
		Effect=material'CO_Final'
	End Object
	Controls(2)=GUITitleBar'ServerInfoHeader'

	Begin Object class=GUITitleBar name=ServerInfoFooter
		WinWidth=1
		WinHeight=0.075
		WinLeft=0
		WinTop=0.925
		bUseTextHeight=false
		StyleName="Footer"
		Justification=TXTA_Center
        bBoundToParent=true
        bScaleToParent=true
	End Object
	Controls(3)=GUITitleBar'ServerInfoFooter'

	Begin Object Class=GUIButton Name=ServerBackButton
		Caption="Close"
		StyleName="SquareMenuButton"
		Hint="Close this menu"
		WinWidth=0.120000
		WinHeight=0.055000
		WinLeft=0.868750
		WinTop=0.934167
        bBoundToParent=true
        bScaleToParent=true
		OnClick=ButtonClicked
	End Object
	Controls(4)=GUIButton'ServerBackButton'

	Begin Object Class=GUITabControl Name=ServerInfoTabs
		WinWidth=1.0
		WinLeft=0
		WinTop=0.1
		WinHeight=0.06
		TabHeight=0.04
		bAcceptsInput=true
		bDockPanels=true
        bBoundToParent=true
        bScaleToParent=true
	End Object
	Controls(5)=GUITabControl'ServerInfoTabs'


	bRequire640x480=false
	bAllowedAsLast=true
    WinLeft=0.2
    WinWidth=0.6
    WinTop=0.1
    WinHeight=0.8

}